=== debian/changelog ===
grantlee5 (5.2.0-3) unstable; urgency=medium

  * Team upload.

  [ Vagrant Cascadian ]
  * Disable fixfilepath reproducibility feature, as it triggers build failures
    when enabled. (Closes: #972302)

 -- Aurélien COUDERC <coucouf@debian.org>  Mon, 11 Jan 2021 17:19:37 +0100

grantlee5 (5.2.0-2) unstable; urgency=medium

  * Upload to unstable.
  * Add hppa as architecture where the tests can fail (the QML engine seems
    broken there too).
  * Bump Standards-Version to 4.5.0, no changes required.
  * Add Rules-Requires-Root: no.
  * Bump the debhelper compatibility to 13:
    - switch the debhelper-compat build dependency to 13
    - stop passing --fail-missing to dh_install, as it is the default now
  * Small changes to copyright.

 -- Pino Toscano <pino@debian.org>  Sun, 16 Aug 2020 17:53:22 +0200

grantlee5 (5.2.0-1) experimental; urgency=medium

  * New upstream release:
    - fixes build with Qt 5.12 (Closes: #939362)
  * Update watch file to the new download location, and allow xz as format.
  * Switch Vcs-* fields to salsa.debian.org.
  * Add the configuration for the CI on salsa.
  * Update the build dependencies according to the upstream build system:
    - bump cmake to 3.5
    - remove libboost-dev, and qtscript5-dev, no more required
    - add qtdeclarative5-dev
  * Update the patches:
    - datatime-fractional.diff: drop, fixed upstream
  * Add Build-Depends-Package in symbols files.
  * Bump the debhelper compatibility to 12:
    - switch the debhelper build dependency to debhelper-compat 12
    - remove debian/compat
    - remove --parallel for dh, as now done by default
    - switch from dh_install to dh_missing for --fail-missing
    - drop the dh_makeshlibs override, as:
      - -V is done by default
      - plugins are no more misdetected as shared libraries, and thus no need
        to manually exclude them
  * Drop the migration from grantlee5-dbg, no more needed after two Debian
    stable releases.
  * Bump Standards-Version to 4.4.1, no changes required.
  * Mark the library packages as Multi-Arch: same.
  * Remove the cccc, and lcov build dependencies, as they are not used during
    the build, or in the test suite run by default.
  * Ship the examples in libgrantlee5-dev.
  * Add a simple autopkgtest that builds the shipped examples.
  * Add the GPG signing key of the upstream tarballs.

 -- Pino Toscano <pino@debian.org>  Wed, 25 Dec 2019 12:52:51 +0100
