=== debian/changelog ===
grantlee5 (5.3.0-1ubuntu1) mantic; urgency=medium

  * d/rules: Add ppc64el and s390x to testsuite_failing_archs.

 -- Rik Mills <rikmills@kde.org>  Sun, 21 May 2023 22:15:49 +0100

grantlee5 (5.3.0-1) experimental; urgency=medium

  * New upstream release.
  * Update the patches:
    - variantIsTrue-float-fix.diff: drop, fixed upstream
  * Update symbols files.

 -- Pino Toscano <pino@debian.org>  Sun, 11 Sep 2022 09:43:09 +0200

grantlee5 (5.2.0-4) unstable; urgency=medium

  * Remove the check for nocheck in $(DEB_BUILD_OPTIONS), as debhelper already
    does not invoke dh_auto_test in compatibility >= 13.
  * Bump Standards-Version to 4.6.1, no changes required.
  * Use /usr/share/dpkg/architecture.mk instead of querying manually for the
    $DEB_HOST_* dpkg vars.
  * Mark the xauth, and xvfb build dependencies as !nocheck, as they are needed
    only when running dh_auto_test.
  * Switch the watch file to version 4, no changes required.
  * Remove inactive Uploaders.
  * Since upstream never cared to make the examples buildable standalone, and
    newer versions will make this even more difficult, then:
    - stop shipping them in libgrantlee5-dev
    - drop the build-examples autopkgtest
    - remove lintian overrides for them

 -- Pino Toscano <pino@debian.org>  Sun, 11 Sep 2022 08:44:01 +0200
