=== debian/control ===
--- 
+++ 
@@ -1,11 +1,9 @@
 Source: grantlee5
 Section: libs
 Priority: optional
-Maintainer: Debian Krap Maintainers <debian-qt-kde@lists.debian.org>
-Uploaders: Bjoern Ricks <bjoern.ricks@intevation.de>,
-           Sune Vuorela <sune@debian.org>,
-           Maximiliano Curia <maxy@debian.org>,
-           Pino Toscano <pino@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Krap Maintainers <debian-qt-kde@lists.debian.org>
+Uploaders: Pino Toscano <pino@debian.org>
 Build-Depends: cmake (>= 3.5~),
                debhelper-compat (= 13),
                pkg-kde-tools,
@@ -13,9 +11,9 @@
                qtdeclarative5-dev (>= 5.4),
                qttools5-dev (>= 5.4),
                qttools5-dev-tools (>= 5.4),
-               xauth,
-               xvfb
-Standards-Version: 4.5.0
+               xauth <!nocheck>,
+               xvfb <!nocheck>,
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Homepage: http://www.grantlee.org/
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/grantlee
