=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

# Disable fixfilepath, as it triggers build failures.
export DEB_BUILD_MAINT_OPTIONS = reproducible=-fixfilepath

testsuite_failing_archs := hppa ia64 ppc64el sparc64 s390x
ifneq (,$(filter $(DEB_HOST_ARCH),$(testsuite_failing_archs)))
  fail_param := || true
endif

%:
	dh $@ --with pkgkde_symbolshelper

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_TESTS=ON -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)"

override_dh_auto_test:
	xvfb-run dh_auto_test $(fail_param)
